<?php

namespace Ticket\Http\Controllers;

use Illuminate\Http\Request;
use Ticket\Http\Controllers\Controller;
use Ticket\Location;
use Ticket\Dsl;
use Validator;
use Response;
use Illuminate\Support\Facades\Input;

//use Session;


class DslController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
        $dsl = Dsl::getDsldetails();
         return view('admin.dsl.dsllist',compact('dsl'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
         $locs = Location::all();
         return view('admin.dsl.dslcreate',compact('locs'));

        
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        if ($request->isMethod('post')) {
            $this->validate($request, [
           'calls' => 'bail|required|max:50',
           'locid' => 'bail|required',
           'contract' => 'bail|required',
           'issue' => 'bail|required|max:150',
           'reason' => 'bail|required|max:150',
           'contacted' => 'bail|required',
           'followup' => 'bail|required',
           'partreq' => 'bail|required',
           'partno' => 'bail|required',
           'partsts' => 'bail|required',
           'sheets' => 'bail|required',
           'contact' => 'bail|required',
           'remarks' => 'bail|required',

           //'mod_status' => 'bail|required|max:50',
       ]);

           $dsl = new Dsl;
           //var_dump($request); die;

               $dsl->open     = $request->calls;
               $dsl->locid    = $request->locid;
               $dsl->type      = $request->contract;
               $dsl->issue      = $request->issue;
               $dsl->reason    = $request->reason;
               $dsl->con_end_user       = $request->contacted;
               $dsl->followup       = $request->followup;
               $dsl->parts_required       = $request->partreq;
               $dsl->partno       = $request->partno;
               $dsl->partstatus       = $request->partsts;
               $dsl->updated       = $request->sheets;
               $dsl->contact       = $request->contact;
               $dsl->remarks       = $request->remarks;
               $dsl->status       = 1;

               
             if($dsl->save()) {
               
               $request->session()->flash('success', 'DSL report created successfully');
               return redirect()->route("admin.dsl.dsllist");
             }


     }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $dsl = Dsl::find($id);
        $locs = Location::all();
    return view('admin.dsl.dsledit',compact('dsl','locs'));


    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
      if ($request->isMethod('patch')) {
        $this->validate($request, [
          'calls' => 'bail|required|max:50',
           'locid' => 'bail|required',
           'contract' => 'bail|required',
           'issue' => 'bail|required|max:150',
           'reason' => 'bail|required|max:150',
           'contacted' => 'bail|required',
           'followup' => 'bail|required',
           'partreq' => 'bail|required',
           'partno' => 'bail|required',
           'partsts' => 'bail|required',
           'sheets' => 'bail|required',
           'contact' => 'bail|required',
           'remarks' => 'bail|required',
          
        ]);
        $dsl = Dsl::find($id);
        
               $dsl->open     = $request->calls;
               $dsl->locid    = $request->locid;
               $dsl->type      = $request->contract;
               $dsl->issue      = $request->issue;
               $dsl->reason    = $request->reason;
               $dsl->con_end_user       = $request->contacted;
               $dsl->followup       = $request->followup;
               $dsl->parts_required       = $request->partreq;
               $dsl->partno       = $request->partno;
               $dsl->partstatus       = $request->partsts;
               $dsl->updated       = $request->sheets;
               $dsl->contact       = $request->contact;
               $dsl->remarks       = $request->remarks;
              if($dsl->save()) {
                
     $request->session()->flash('success', 'DSL Updated Successfully');
          return redirect("dsl");

      }
    }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}
