<?php

namespace Ticket\Http\Controllers;

use Illuminate\Http\Request;
use Ticket\Asset;
use Ticket\Master;
use Ticket\Oem;
use Ticket\Oemmodel;
use Ticket\Location;
use Ticket\Customer;
use Ticket\Ticket;
use Ticket\Attachment;
use Ticket\Category;
use Ticket\Tech;
use Ticket\Material;
use Session;
use Mail;
use Ticket\Mail\MaterialRequestApprove;
use Ticket\Mail\MaterialRequest;


class MaterialController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
       $materials = Material::all();
         return view('engineer.request.requestlist',compact('materials'));
    }

     public function req_index()
    {
       $materials = Material::all()->sortByDesc("id");
         return view('admin.request.requestlist',compact('materials'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $oems = Oem::all();
         $locs = Location::all();
         $customers = Customer::all();
         $categories = Category::all();
         return view('engineer.request.requestcreate',compact('oems','locs','customers','categories'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
         $requ = new Material;

date_default_timezone_set("Asia/Kolkata");
//print_r($_POST);exit; 

  $form_id= Material::getLastNo($request->warehouse);
 
if($form_id){
      $result = str_replace('MRF'.$request->warehouse, '', $form_id->form_no);
      $t= $result+1;
      if($t>9)
      {
        $formno='MRF'.$request->warehouse.'00'.$t;
      }
      else
      {
         $formno='MRF'.$request->warehouse.'000'.$t;
      }
}
else{
    $formno='MRF'.$request->warehouse.'0001';
}

               $requ->loc_id      = $request->location;
               $requ->c_id        = $request->customer;
               $requ->tech_id     = Session::get('uid');
               $requ->cat_id      = $request->category;
               $requ->serial_id   = $request->serial_id;
               $requ->oem_id      = $request->oem;
               $requ->mod_id      = $request->model;
               $requ->prt_id      = $request->prt;               
               $requ->prt_no      = $request->prt_no;
               $requ->prt_desc    = $request->prt_desc;
               $requ->prt_qty     = $request->qty;
               $requ->remark      = $request->remark;
               $requ->warehouse   = $request->warehouse;
               $requ->service_no  = $request->service_no;
               $requ->form_no     = $formno;
               $requ->status      = 'Pending';              
               if($requ->save()) {
                $materials = Material::getRequestById($requ->id);

        
           Mail::to('kiran@ssquadglobal.com')
          ->bcc('ajo@doctorslink.in')         
            ->send(new MaterialRequest($materials));
       
        
              $request->session()->flash('success', 'Material Request Created Successfully');
               return redirect('request');
               }
}

           
               

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
         $materials = Material::getAllMatDetails($id);
         return view('engineer.request.mrf_report',compact('materials'));
    }

    public function admin_show($id)
    {
         $materials = Material::getAllMatDetails($id);
         return view('admin.request.mrf_report',compact('materials'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
       $materials = Material::getRequestById($id);
        return view('admin.request.requestedit',compact('materials'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request)
    {
      $materials = Material::find($request->id);
      $materials->status     = $request->approve;
      if($materials->save()) {
        $materials = Material::getRequestById($request->id);

        if($request->approve=='Approved'){
           Mail::to($materials->tc_email)
           ->bcc('ajo@doctorslink.in')         
            ->send(new MaterialRequestApprove($materials));
        }
        
        $request->session()->flash('success', 'Material Request Edited Successfully');

               return redirect("request_index");
      }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}
