@extends('layouts.tdashboard')
@section('content')

 <!-- Right side column. Contains the navbar and content of the page -->
            <aside class="right-side">
                <!-- Content Header (Page header) -->
                <section class="content-header">
                    <h1>
                        Manage State
                    </h1>
                    <!-- <ol class="breadcrumb">
                        <li><a href="dashboard.html"><i class="fa fa-dashboard"></i> Home</a></li>
                        <li class="active">Add State</li>
                    </ol> -->
                </section>

                <!-- Main content -->
                <section class="content">
                    <div class="row">
                        <div class="col-md-12">

                            <div class="box box-danger box-widget">
                                <div class="widget-head clearfix">
                                    <span class="h-icon"><i class="fa fa-align-justify"></i></span>
                                    <h4 class="box-title">Add State</h4>
                                </div><!-- /.box-header -->
                                <div class="box-body table-responsive">
                                <div class="col-md-6">
                                    <div class="form-group">
                                        

<!--  <form class="form-horizontal" role="form" method="PUT" action="{{ url('oem/store') }}"> -->
{!! Form::open(['action' => 'StateController@tstore', 'method' => 'post', 'style' => 'display:inline !important;']) !!}
 {{ csrf_field() }}
<div class="form-group">
                          <label>Choose State</label>
                          <select class="form-control" name="con_id" id="con_id">
                            <option value="">Select Country</option>
                             @foreach ($countries as $country)
                            <option value="{{ $country->id}}">{{$country->con_name}}</option>
                            @endforeach
                          </select>
                        </div>
                                        

                </div>
                </div>
                <div class="col-md-6">
                <label>Enter State</label>
                    <div class="input-group">
                                            <div class="input-group-addon">
                                                <i class="fa fa-map-marker" aria-hidden="true"></i>
                                            </div>
                                            
                                            <input type="text" class="form-control" style="float:left; width:75%; margin-right:5px;" name="st_name" required />
                                            <button type="submit" class="btn btn-danger">Add State</button>
                                        </div>
                                        {!! Form::close() !!}


                                    </div>

                </div>
                </div>
                </div>
                                <div class="box box-danger box-widget">
                                <div class="widget-head clearfix">
                                    <span class="h-icon"><i class="fa fa-align-justify"></i></span>
                                    <h4 class="box-title">State List</h4>
                                </div><!-- /.box-header -->
                                <div class="col-md-12 box-body">


                                    <table id="tstlist" class="table dt-table table-striped table-hover table-bordered matmix-dt">
                                            <thead style="background:#e9e9e9;">
                                                <tr>
                                                    <th width="15%">No#</th>
                                                     <th width="25%">Country</th>
                                                    <th width="20%">State</th>
                                                    <th width="20%">Status</th>
                                                    <th width="25%">Action</th>
                                                </tr>
                                            </thead>
                                            <tbody>
                                            @foreach ($states as $index => $element)
                                                <tr>
                                                    <td>{{$index+1}}</td>
                                                    <td>{{$element->con_name}}</td>
                                                    <td>{{$element->st_name}}</td>
                                                    <?php  if($element->st_status == 1){

                                                        $status = 'Active';

                                                        $class = 'label label-info';

                                                    } else {

                                                        $status = 'In-Active';

                                                        $class = 'label label-warning';

                                                    } ?>
                                        <td><div class="activeTab">
                                        <label class="<?php echo $class; ?>"><?php echo $status; ?></label>
                                        </div>
                                        </td>
                            <td>
                            
                              <a class="btn btn-primary" href="{{ url('tstateedit', $element->id) }}">
             <span class="glyphicon glyphicon-edit"></span> Edit
           </a>
           <button class="btn btn-danger" data-id="{{$element->id}}" data-title="{{$element->st_name}}" onclick="delete_st(<?php echo $element->id ?>);">
              <span class="glyphicon glyphicon-trash"></span> Delete
            </button>

                            </td>
                                                </tr>
                                                @endforeach

                                            </tbody>
                                        </table>
                                </div>
                                </div><!-- /.box-body -->
                            </div><!-- /.box -->

                            <!-- /.box -->

                        </div><!-- /.col (left) -->
                    </div><!-- /.row -->

                </section><!-- /.content -->
            </aside><!-- /.right-side -->

@endsection
<script type="text/javascript">

    

    function delete_st(stId) {

         swal({

            title: "Are you sure?",

            text: "You will not be able to recover this data!",

            type: "warning",

            showCancelButton: true,

            confirmButtonClass: "btn-danger",

            confirmButtonText: "Yes, delete it!",

            cancelButtonText: "No, cancel the actions!",

            closeOnConfirm: false,

            closeOnCancel: false

         },

         function(isConfirm) {

            if (isConfirm) {

               //swal("Deleted!", "State has been deleted.", "success");

               //ajax delete data to database country.destroy

               $.ajax({
                  type: "GET",
                  // url: '<?php //echo url('/delete_con')?>/'
                   url: "{{url('/tdelete_st')}}/"+stId,
                  //data: {id:stId},

                  //dataType: "JSON",

                  success: function(data) {
                   

                    console.log(data)

                     //table.ajax.reload(null, false); //just reload table

                      $("#tstlist").load(window.location + " #tstlist");

                       swal("Deleted!", "State has been deleted.", "success");

                 },

                  error: function(jqXHR, textStatus, errorThrown) {
                     alert('Error deleting data');

                 }

               });

            } else {

               swal("Cancelled", "Data is safe :)", "error");

            }

         });

      }  



</script>