<?php

namespace Ticket\Http\Controllers;

use Illuminate\Http\Request;
use Ticket\Location;
use Ticket\Assistance;
use Session;

class AssistanceContoller extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
         
         $assis = Assistance::all();
         
          //$locs = Assistance::getLocation($assis->loc_id);         
        return view('customer.assistance.assistancelist',compact('assis'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $locs = Location::all();
        return view('customer.assistance.assistancecreate',compact('locs'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {

        if ($request->isMethod('post')) {
       
           $assis = new Assistance;
           //var_dump($request); die;

               $assis->skills     = $request->skills;
               $assis->no_fe    = $request->num;
               $assis->date      = date('Y-m-d',strtotime($request->dates));
               $assis->time       = date('H:i:s ',strtotime($request->times));
               $assis->loc_id      = $request->location;
               $assis->c_id      = Session::get('uid');
                
              if($assis->save()) {
                 
               $request->session()->flash('success', 'FE Assistance Created Successfully');
               return redirect("assistance");
             }


     }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
             $assistance=Assistance::find($id);
             $locs = Location::all();
             return view('customer.assistance.assistanceedit',compact('assistance','locs'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        if ($request->isMethod('patch')) {
        $this->validate($request, [
            'skills' => 'bail|required',
            'num' => 'bail|required',
            'dates' => 'bail|required',
            'times' => 'bail|required',
            'location' => 'bail|required',
        ]);
         $assistance=Assistance::find($id);
        $assistance->skills     = $request->skills;
               $assistance->no_fe    = $request->num;
               $assistance->date      = date('Y-m-d',strtotime($request->dates));
               $assistance->time       = date('H:i:s ',strtotime($request->times));
               $assistance->loc_id      = $request->location;
               $assistance->c_id      = Session::get('uid');
        
        if($assistance->save()) {
          $request->session()->flash('success', 'FE Assistance Updated Successfully');
          return redirect()->route("assistance.index");
        }

      }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
       $assistance=Assistance::find($id);
        if($assistance->delete()){

            return redirect()->route("assistance.index")->with('success', 'Deleted successfully');
        }else{
            return redirect()->route("assistance.index")->with('error','Delete failed');
        }
    }
}
