<?php

namespace Ticket\Http\Controllers;

use Ticket\Location;
use Illuminate\Http\Request;
use DB;

class LocationController extends Controller
{
  // public function __construct()
  // {
  //     $this->middleware('auth');
  // }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
         $locations = Location::getAllLoc();
         //var_dump($locations);die;
         return view("admin.locations.locationlist", compact('locations'));
    }

    /*for engg module*/
    public function tindex()
    {
         $locations = Location::getAllLoc();
         //var_dump($locations);die;
         return view("engineer.locations.locationlist", compact('locations'));
    }
    /*engg ends here*/

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
      $countries = Location::getCountry();
      $states = Location::getState();
      $cities = Location::getCity();
       return view("admin.locations.locationcreate",compact('countries','states','cities'));
    }

    public function tcreate()
    {
      $countries = Location::getCountry();
      $states = Location::getState();
      $cities = Location::getCity();
       return view("engineer.locations.locationcreate",compact('countries','states','cities'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
      if ($request->isMethod('post')) {
       $this->validate($request, [
           'location' => 'bail|required|max:50',
       ]);

           $location = new Location;
               $location->con_id     = $request->country;
               $location->st_id     = $request->state;
               $location->ct_id     = $request->city;
               $location->loc_name     = $request->location;
               $location->loc_status ='1';

             if($location->save()) {
               $request->session()->flash('success', 'Location Created Successfully');
               return redirect()->route("location.index");
             }


     }
    }

    /*enginner module*/
    public function tstore(Request $request)
    {
      if ($request->isMethod('post')) {
       $this->validate($request, [
           'location' => 'bail|required|max:50',
       ]);

           $location = new Location;
               $location->con_id     = $request->country;
               $location->st_id     = $request->state;
               $location->ct_id     = $request->city;
               $location->loc_name     = $request->location;
               $location->loc_status ='1';

             if($location->save()) {
               $request->session()->flash('success', 'Location Created Successfully');
               return redirect("tlocindex");
             }


     }
    }

    /*engg ends here*/

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
      $location=Location::find($id);
      $countries = Location::getCountry();
      $states = Location::getState();
      $cities = Location::getCity();
        return view('admin.locations.locationedit',compact('location','countries','states','cities'));
    }

    /*engg module*/

    public function tedit($id)
    {
      $location=Location::find($id);
      $countries = Location::getCountry();
      $states = Location::getState();
      $cities = Location::getCity();
        return view('engineer.locations.locationedit',compact('location','countries','states','cities'));
    }
    /*engg ends here*/
    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
      if ($request->isMethod('patch')) {
        $this->validate($request, [
          'country' => 'bail|required',
          'state' => 'bail|required',
          'city' => 'bail|required',
          'loc_name' => 'bail|required,'.$id.'|max:50',
        ]);
        $location = Location::find($id);
        $location->con_id 	 = $request->country;
        $location->st_id 	 = $request->state;
        $location->ct_id 	 = $request->city;
        $location->loc_name 	 = $request->location;
        if($location->save()) {
          $request->session()->flash('success', 'Location Updated Successfully');
          return redirect()->route("location.index");
        }

      }
    }

    /*engg module*/
    public function tupdate(Request $request)
    {
      if ($request->isMethod('post')) {
        $this->validate($request, [
          'country' => 'bail|required',
          'state' => 'bail|required',
          'city' => 'bail|required',
          'loc_name' => 'bail|required,'.$request->id.'|max:50',
        ]);
        $location = Location::find($request->id);
        $location->con_id    = $request->country;
        $location->st_id   = $request->state;
        $location->ct_id   = $request->city;
        $location->loc_name    = $request->location;
        if($location->save()) {
          $request->session()->flash('success', 'Location Updated Successfully');
          return redirect("tlocindex");
        }

      }
    }

    /**/

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
      $location = Location::find($id);
        if($location->delete()){

            return redirect()->route("location.index")->with('success', 'Deleted successfully');
        }else{
            return redirect()->route("location.index")->with('error','Delete failed');
        }
    }

    /*engg module*/
    public function tdestroy(Request $request)
    {
      $location = Location::find($request->id);
        if($location->delete()){
            $request->session()->flash('success', 'Location deleted successfully');
            return redirect("tlocindex");
            //return redirect()->route("location.index")->with('success', 'Deleted successfully');
        }else{

            return redirect("tlocindex");

            //return redirect()->route("location.index")->with('error','Delete failed');
        }
    }
    /**/
    public function myformAjax($id)

    {
        //DB::enableQueryLog();
        $states = Location::getStateByCountry($id);

        //echo '<pre>'; print_r($states);die;
        return json_encode($states);

    }

    public function myformctAjax($id)

    {
        //DB::enableQueryLog();
        $cities = Location::getCityByState($id);

        //echo '<pre>'; print_r($states);die;
        return json_encode($cities);

    }

}
