<?php

namespace Ticket\Http\Controllers;
use Ticket\Http\Controllers\Controller;
use Ticket\Oemmodel;
use Ticket\Oem;
use Ticket\Category;
use Ticket\Serial;
use Illuminate\Http\Request;

class OemmodelController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
     // public function __construct()
     // {
     //     $this->middleware('auth');
     // }

    public function index()
    {
        
        $oems = Oemmodel::getOems();
        $models = Oemmodel::getOemname();
        $categories = Category::all();
        return view('admin.oemmodel.modellist',compact('oems','models','categories'));
    }

    public function tmodel() 
    {
        
        $oems = Oemmodel::getOems();
        $models = Oemmodel::getOemname();
         $categories = Category::all();
        return view('engineer.oemmodel.modellist',compact('oems','models','categories'));
    }
    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
        if ($request->isMethod('post')) {
         $this->validate($request, [
             'mod_name' => 'bail|required|max:50',
             //'mod_status' => 'bail|required|max:50',
         ]);

             $oemmodel = new Oemmodel;
             //var_dump($request); die;

                 $oemmodel->cat_id     = $request->get('category');
                 $oemmodel->serial_id     = $request->get('serial_id');
                 $oemmodel->oem_id     = $request->get('oem');
                 $oemmodel->mod_name     = $request->mod_name;
                 $oemmodel->mod_status = '1';
                 //$oem->mod_status     = $request->oem_name;

               if($oemmodel->save()) {
                 $request->session()->flash('success', 'Model Created Successfully');
                 return redirect()->route("model.index");
               }


       }
    }


    /* add model for enginner */
    public function tstore(Request $request)
    {
        //
        if ($request->isMethod('post')) {
         $this->validate($request, [
             'mod_name' => 'bail|required|max:50',
             //'mod_status' => 'bail|required|max:50',
         ]);

             $oemmodel = new Oemmodel;
             //var_dump($request); die;

                $oemmodel->cat_id     = $request->get('category');
                 $oemmodel->serial_id     = $request->get('serial_id');
                 $oemmodel->oem_id     = $request->get('oem');
                 $oemmodel->mod_name     = $request->mod_name;
                 $oemmodel->mod_status = '1';
                 //$oem->mod_status     = $request->oem_name;

               if($oemmodel->save()) {
                 $request->session()->flash('success', 'Model Created Successfully');
                 //return redirect()->route("techmodel");
                 return redirect("techmodel");
               }


       }
    }

    /*enginner ends here*/

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {   $oems = Oemmodel::getOems();
        $categories = Category::all();
         $serials = Serial::all();
        //getOems();
        $oemmodel = Oemmodel::find($id);

        return view('admin.oemmodel.modeledit',compact('oemmodel','oems','categories','serials'));
    }

    /* engineer model edit*/

    public function tedit($id)
    {   $oems = Oemmodel::getOems();
        $categories = Category::all();
         $serials = Serial::all();
        //getOems();
        $oemmodel = Oemmodel::find($id);

        return view('engineer.oemmodel.modeledit',compact('oemmodel','oems','categories','serials'));
    }

    /* engineer ends here*/

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
      if ($request->isMethod('patch')) {
        $this->validate($request, [
            'oem' => 'bail|required',
            'mod_name' => 'bail|required|unique:oemmodels,mod_name,'.$id.'|max:50',
        ]);
        $oemmodel = Oemmodel::find($id);
        $oemmodel->oem_id 	 = $request->get('oem');
        $oemmodel->serial_id = $request->get('serial_id');
        $oemmodel->cat_id   = $request->get('category');
        $oemmodel->mod_name 	 = $request->mod_name;
        if($oemmodel->save()) {
          $request->session()->flash('success', 'Oem Updated Successfully');
          return redirect()->route("model.index");
        }

      }
    }


    /*engineer update*/
    public function tupdate(Request $request)
    { 
        //echo 'hhihihih'.$request->id; exit(); 
      if ($request->isMethod('post')) {
        
        $oemmodel = Oemmodel::find($request->id);
         $oemmodel->oem_id   = $request->get('oem');
        $oemmodel->serial_id = $request->get('serial_id');
        $oemmodel->cat_id   = $request->get('category');
        $oemmodel->mod_name      = $request->mod_name;
        if($oemmodel->save()) {
          $request->session()->flash('success', 'Oem Updated Successfully');
          return redirect("techmodel");
        }

      }
    }

    /**/


    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
      $oemmodel = Oemmodel::find($id);
        if($oemmodel->delete()){

            return redirect()->route("model.index")->with('success', 'Deleted successfully');
        }else{
            return redirect()->route("model.index")->with('error','Delete failed');
        }
    }

    public function tdestroy(Request $request,$id)
    {
      $oemmodel = Oemmodel::find($id);
        if($oemmodel->delete()){

            $request->session()->flash('success', 'Model deleted successfully'); 
            return redirect("techmodel");
            //return redirect()->route("model.index")->with('success', 'Deleted successfully');
        }else{
             $request->session()->flash('failed', 'Delete failed'); 
            return redirect("techmodel");//->route("model.index")->with('error','Delete failed');
        }
    }
     public function modelAjax($id)
   {
     $oems = Oemmodel::getOemsByserial($id);
    
     return json_encode($oems);
   }
}
