<?php

namespace Ticket;

use Illuminate\Database\Eloquent\Model;
use DB;

class Location extends Model
{
  protected $fillable = ['con_id', 'st_id', 'ct_id', 'loc_name', 'loc_status', 'created_at', 'updated_at'];
  protected static function getCountry() {
    $results = DB::table('countries')
                 ->select('id', 'con_name')
                 ->get();

    return $results;
}
protected static function getState() {
  $results = DB::table('states')
               ->select('id', 'st_name')
               ->get();

  return $results;
}
protected static function getCity() {
  $results = DB::table('cities')
               ->select('id', 'ct_name')
               ->get();

  return $results;
}

protected static function getAllLoc() {
  $results = DB::table('locations')
   ->select('locations.id','locations.loc_name','countries.con_name', 'states.st_name', 'cities.ct_name')
    ->join('countries', 'countries.id', '=', 'locations.con_id')
    ->join('states', 'states.id', '=', 'locations.st_id')
    ->join('cities', 'cities.id', '=', 'locations.ct_id')
    ->where('locations.loc_status', '=', '1')
    ->get(); // Notice the shares.* here
    return $results;
}

protected static function getStateByCountry($country) {
  $states = DB::table('states')->select("st_name","id")
              ->where("con_id", '=', $country)->get();

        //     $queries = DB::getQueryLog();
        // echo '<pre>'; print_r($queries);die;
  return $states;
}

protected static function getCityByState($state) {
  $cities = DB::table('cities')->select("ct_name","id")
              ->where("st_id", '=', $state)->get();

        //     $queries = DB::getQueryLog();
        // echo '<pre>'; print_r($queries);die;
  return $cities;
}
}
