<?php

namespace Ticket\Http\Controllers;
use Ticket\Http\Controllers\Controller;
use Ticket\Category;
use Illuminate\Http\Request;
use Validator;
use Response;
use Illuminate\Support\Facades\Input;

class CategoryController extends Controller
{
  // public function __construct()
  // {
  //     $this->middleware('auth');
  // }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
       $categories = Category::all();
      return view("admin.asset.categorylist", compact('categories'));
    }


    public function tindex()
    {
       $categories = Category::all();
      return view("engineer.asset.categorylist", compact('categories'));
    }

    // public function toem()
    // {
    //    $oems = Oem::all();
    //   return view("engineer.oem.oemlist", compact('oems'));
    // }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
         return view('admin.asset.categorylist');
    }


    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
       if ($request->isMethod('post')) {
        $this->validate($request, [
            'cat_name' => 'bail|required|max:50',
        ]);

            $category = new Category;
                $category->cat_name     = $request->cat_name;
                 $category->cat_status     = '1';

              if($category->save()) {
                $request->session()->flash('success', 'Asset Created Successfully');
                return redirect()->route("category.index");
              }


      }
    }

    /**
    
    add OEM from enginner module    
    **/
    public function tstore(Request $request)
    {
        if ($request->isMethod('post')) {
        $this->validate($request, [
            'cat_name' => 'bail|required|max:50',
        ]);

            $category = new Category;
                $category->cat_name     = $request->cat_name;
                 $category->cat_status     = '1';

              if($category->save()) {
                $request->session()->flash('success', 'Asset Created Successfully');
                return redirect("tcatindex");
              }


      }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
      $category=Category::find($id);
        return view('admin.asset.categoryedit',compact('category'));
    }

    public function tedit($id)
    {
        $category=Category::find($id);
        return view('engineer.asset.categoryedit',compact('category'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
      if ($request->isMethod('patch')) {
        $this->validate($request, [
            'cat_name' => 'bail|required|max:50',
        ]);
        $category = Category::find($id);
        $category->cat_name 	 = $request->cat_name;
        $category->cat_status      = '1';
        
        if($category->save()) {
          $request->session()->flash('success', 'Category Updated Successfully');
          return redirect()->route("category.index");
        }

      }
    }

    public function tupdate(Request $request)
    {
      if ($request->isMethod('post')) {
        $this->validate($request, [
            'cat_name' => 'bail|required|max:50',
        ]);
        $category = Category::find($request->id);
        $category->cat_name      = $request->cat_name;
        $category->cat_status      = '1';
        
        if($category->save()) {
          $request->session()->flash('success', 'Category Updated Successfully');
          return redirect("tcatindex");
        }

      }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
     $category = Category::find($id);
        if($category->delete()){

            return redirect()->route("category.index")->with('success', 'Deleted successfully');
        }else{
            return redirect()->route("category.index")->with('error','Delete failed');
        }

    }


    public function tdestroy(Request $request,$id)
    {
      $category = Category::find($id);
        if($category->delete()){
        $request->session()->flash('success', 'Category deleted Successfully');  
        return redirect("tcatindex"); 

        }else{
            return redirect("tcatindex")->with('error','Delete failed');
        }

    }
}
