<?php

namespace Ticket\Http\Controllers;
use Ticket\Http\Controllers\Controller;
use Ticket\Master;
use Ticket\Oem;
use Ticket\Oemmodel;
use Ticket\Location;
use Ticket\Country;
use Ticket\State;
use Ticket\City;
use Ticket\Category;
use Ticket\Serial;
use Excel;

use Illuminate\Http\Request;

class MasterController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */

     // public function __construct()
     // {
     //     $this->middleware('auth');
     // }

    public function index()
    {
        $master = Master::all();
        $oems = Oem::all();
        $locs = Location::all();
        $categories = Category::all();
        $oemnames = Master::getOemname();
        return view('admin.master.master',compact('master','oems','locs','oemnames','categories'));
    }

    public function tindex()
    {
        $master = Master::all();
        $oems = Oem::all();
        $locs = Location::all();
        $categories = Category::all();
        $oemnames = Master::getOemname();
        return view('engineer.master.master',compact('master','oems','locs','oemnames','categories'));
    }

    public function downloads()
    {
        
        return view('engineer.master.download');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
      if ($request->isMethod('post')) {
       $this->validate($request, [
          'category' => 'bail|required|max:50',
          'serial_id' => 'bail|required|max:50',
           'oem' => 'bail|required|max:50',
           'model' => 'bail|required|max:50',
           'loc' => 'bail|required|max:50',
           'pnumber' => 'bail|required|max:50',
           'partdesc' => 'bail|required|max:50',
           'pqty' => 'bail|required|max:50',
           'sn' => 'bail|required|max:75',
           //'mod_tatus' => 'bail|required|max:50',
       ]);

           $master = new Master;
           //var_dump($request); die;

               $master->cat_id     = $request->category;
               $master->serial_id     = $request->serial_id;
               $master->oem_id     = $request->oem;
               $master->mod_id     = $request->model;
               $master->loc_id = $request->loc;
               $master->prt_no     = $request->pnumber;
               $master->prt_desc     = $request->partdesc;
               $master->prt_qty = $request->pqty;
               $master->sn = $request->sn;
               $master->serial_no = $request->serial_no;
               $master->track = $request->track;
               $master->location_of_tray = $request->location_of_tray;
               $master->start_date = date('Y-m-d',strtotime($request->st_date));
               $master->end_date = date('Y-m-d',strtotime($request->end_date));
               $master->mas_status = '1';
               //$oem->mod_status     = $request->oem_name;

             if($master->save()) {
               $request->session()->flash('success', 'Asset Created Successfully');
               return redirect()->route("master.index");
             }


     }
    }

    public function tstore(Request $request)
    {
      if ($request->isMethod('post')) {
       $this->validate($request, [
          'category' => 'bail|required|max:50',
          'serial_id' => 'bail|required|max:50',
           'oem' => 'bail|required|max:50',
           'model' => 'bail|required|max:50',
           'loc' => 'bail|required|max:50',
           'pnumber' => 'bail|required|max:50',
           'partdesc' => 'bail|required|max:50',
           'pqty' => 'bail|required|max:50',
           'sn' => 'bail|required|max:75',
           //'mod_tatus' => 'bail|required|max:50',
       ]);

           $master = new Master;
           //var_dump($request); die;

               $master->cat_id     = $request->category;
              $master->serial_id     = $request->serial_id;
               $master->oem_id     = $request->oem;
               $master->mod_id     = $request->model;
               $master->loc_id = $request->loc;
               $master->prt_no     = $request->pnumber;
               $master->prt_desc     = $request->partdesc;
               $master->prt_qty = $request->pqty;
               $master->sn = $request->sn;
               $master->serial_no = $request->serial_no;
               $master->track = $request->track;
               $master->location_of_tray = $request->location_of_tray;
               $master->start_date = date('Y-m-d',strtotime($request->st_date));
               $master->end_date = date('Y-m-d',strtotime($request->end_date));
               $master->mas_status = '1';
               //$oem->mod_status     = $request->oem_name;

             if($master->save()) {
               $request->session()->flash('success', 'Asset Created Successfully');
               return redirect("tmastindex");
             }


     }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
      //$assets = Master::all();
       $oems = Oem::all();
       $models = Oemmodel::all();
       $locs = Location::all();
       $master = Master::find($id);
       $serials = Serial::all();
       $categories = Category::all();
    //  var_dump($master); die;
      //$oemnames = Master::getOemname();
      return view('admin.master.masteredit',compact('master','oems','models','locs','categories','serials'));
    }
    /*engg module*/
    public function tedit($id)
    {
      //$assets = Master::all();
       $oems = Oem::all();
       $models = Oemmodel::all();
       $locs = Location::all();
     
       $master = Master::find($id);
       $serials = Serial::all();
    //  var_dump($master); die;
      //$oemnames = Master::getOemname();
       $categories = Category::all();
      return view('engineer.master.masteredit',compact('master','oems','models','locs','categories','serials'));
    }
    /*engg ends here*/

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
      if ($request->isMethod('patch')) {
        $this->validate($request, [
            'oem' => 'bail|required|max:50',
            'model' => 'bail|required|max:50',
            'loc' => 'bail|required|max:50',
            'pnumber' => 'bail|required|max:50',
            'partdesc' => 'bail|required|max:50',
            'pqty' => 'bail|required|max:50',
            'sn' => 'bail|required|max:50',
        ]);
        //var_dump($request); die;
        $master = Master::find($id);
        $master->cat_id   = $request->category;
        $master->serial_id     = $request->serial_id;
        $master->oem_id 	 = $request->oem;
        $master->mod_id 	 = $request->model;
        $master->loc_id 	 = $request->loc;
        $master->prt_no 	 = $request->pnumber;
        $master->prt_desc 	 = $request->partdesc;
        $master->prt_qty 	 = $request->pqty;
        $master->sn 	 = $request->sn;
        $master->serial_no = $request->serial_no;
        $master->track = $request->track;
        $master->location_of_tray = $request->location_of_tray;
        $master->start_date = date('Y-m-d',strtotime($request->st_date));
        $master->end_date = date('Y-m-d',strtotime($request->end_date));
        if($master->save()) {
          $request->session()->flash('success', 'Asset Master Updated Successfully');
          return redirect()->route("master.index");
        }

      }
    }

    /*Engg module */
     public function tupdate(Request $request)
    {
      if ($request->isMethod('post')) {
        $this->validate($request, [
            'oem' => 'bail|required|max:50',
            'model' => 'bail|required|max:50',
            'loc' => 'bail|required|max:50',
            'pnumber' => 'bail|required|max:50',
            'partdesc' => 'bail|required|max:50',
            'pqty' => 'bail|required|max:50',
            'sn' => 'bail|required|max:50',
        ]);
        //var_dump($request); die;
        $master = Master::find($request->id);
         $master->cat_id   = $request->category;
          $master->serial_id     = $request->serial_id;
        $master->oem_id    = $request->oem;
        $master->mod_id    = $request->model;
        $master->loc_id    = $request->loc;
        $master->prt_no    = $request->pnumber;
        $master->prt_desc    = $request->partdesc;
        $master->prt_qty   = $request->pqty;
        $master->sn    = $request->sn;
        $master->serial_no = $request->serial_no;
        $master->track = $request->track;
        $master->location_of_tray = $request->location_of_tray;
        $master->start_date = date('Y-m-d',strtotime($request->st_date));
               $master->end_date = date('Y-m-d',strtotime($request->end_date));
        if($master->save()) {
          $request->session()->flash('success', 'Asset Master Updated Successfully');
          return redirect("tmastindex");
        }

      }
    }
    /*engg ends here*/

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
      $master = Master::find($id);
        if($master->delete()){

            return redirect()->route("master.index")->with('success', 'Deleted successfully');
        }else{
            return redirect()->route("master.index")->with('error','Delete failed');
        }
    }

    /*engg module*/
    public function tdestroy(Request $request)
    {
      $master = Master::find($request->id);
        if($master->delete()){
            $request->session()->flash('success', 'Asset Master Deleted Successfully');
            return redirect("tmastindex");
        }else{
            return redirect("tmastindex");
        }
    }
    /*engg ends here*/
   public function modelAjax($id)
   {
     $models = Master::getModelByOem($id);

    //echo '<pre>'; print_r($models);die;
     return json_encode($models);
   }

   public function showCsv(){

   return view('admin.master.csv',compact(''));

   }
   public function serachAjax(Request $request)
   {
    $master = Master::all();
        $oems = Oem::all();
        $locs = Location::all();
        $categories = Category::all();
     $results = Master::getSerachResult($request->serach);
     //print_r($results);exit;
 return view('admin.master.masterserach',compact('results','oems','locs','oemnames','categories'));
   }
   public function serachAjaxTech(Request $request)
   {
    $master = Master::all();
        $oems = Oem::all();
        $locs = Location::all();
        $categories = Category::all();
     $results = Master::getSerachResult($request->serach);
     //print_r($results);exit;
 return view('engineer.master.masterserach',compact('results','oems','locs','oemnames','categories'));
   }


   /*Engg module */
   public function tshowCsv(){

   return view('engineer.master.csv');

   }

   /*engg ends here*/

     /**
      * Import file into database Code
      *
      * @var array
      */
 	public function importExcel(Request $request)
 	{
//echo $request->hasFile('import_file');exit;
 		if($request->hasFile('import_file')){
 			$path = $request->file('import_file')->getRealPath();
$data = Excel::load($path, function($reader) {})->get();

   $filename = time().'.'.$request->import_file->getClientOriginalExtension();
 $t=$request->import_file->move('uploaded_csv', $filename);

 			if(!empty($data) && $data->count()){

 				foreach ($data->toArray() as $key => $v) {
          
 					if(!empty($v)){
 //echo '<pre>';print_r($value);echo '</pre>';
 						//foreach ($value as $key2 => $v) {  
           //  echo '<pre>'; print_r($v);echo '</pre>';exit;


              $catname=  Master::getCatIdByName($v['asset']);
              if($catname)
              $catname= $catname->id;
              else
              {
              $catNew = Category::create([
                   'cat_name' => $v['asset'],
                   'cat_status' => '1',
                              ]);
              $catname = $catNew->id;
             }
               $serialno=  Master::getSerialIdByName($catname,$v['asset_serial_no']); 
              if($serialno)
              $serialno= $serialno->id;
            else
            {
              $SerNew = Serial::create([
                   'cat_id' => $catname,
                   'serial_no' => $v['asset_serial_no'],
                              ]);
              $serialno = $SerNew->id;
             // return back()->with('error','Please Check your file, Something is wrong there.');
            }

            $oemname=  Master::getOemIdByName($catname,$serialno,$v['oem']);
              if($oemname)
              $oname= $oemname->id;
              else
              {
              $oemNew = Oem::create([
                   'cat_id'   =>$catname,
                   'serial_id'=>$serialno,
                   'oem_name' => $v['oem'],
                   'oem_status' => '1',
                              ]);
              $oname = $oemNew->id;
             }
              $modelName= Master::getModIdByName($catname,$serialno,$oname,$v['model']);

             if($modelName)
              $modname= $modelName->id;
          	  
              else
              {
              $modNew = Oemmodel::create([
              	   'cat_id'   =>$catname,
                   'serial_id'=>$serialno,
                   'oem_id'=>$oname,
                   'mod_name' => $v['model'],
                   'mod_status' => '1',
                              ]);
              $modname = $modNew->id;
             }
$conName= Master::getConIdByName($v['country']);
             if($conName)
              $cname= $conName->id;

          	
              else
              {
              $cNew = Country::create([
              	   'con_name'=>$v['country'],
              	   'con_status'=>'1',
                              ]);
              $cname = $cNew->id;
             }
$stName= Master::getStateIdByName($cname,$v['state']);
             if($stName)
              $sname= $stName->id;

              else
              {
              $sNew = State::create([
              	   'con_id'=>$cname,
              	   'st_name'=>$v['state'],
              	   'st_status'=>'1',
                              ]);
              $sname = $sNew->id;
             }
  $ctName= Master::getCityIdByName($sname,$v['city']);
             if($ctName)
              $ccname= $ctName->id;

          	  
              else
              {
              $ccNew = City::create([
              	   'st_id'=>$sname,
              	   'ct_name'=>$v['city'],
              	   'ct_status'=>'1',
                              ]);
              $ccname = $ccNew->id;
             }

 $locName= Master::getLocIdByName($cname,$sname,$ccname,$v['location']);
             if($locName)
              $lname= $locName->id;

          	
              else
              {
              $locNew = Location::create([
              	   'con_id'=>$cname,
              	   'st_id'=>$sname,
              	   'ct_id'=>$ccname,
                   'loc_name'=>$v['location'],
                   'loc_status'=> '1', 
                              ]);
              $lname = $locNew->id;
             }

             $created=date('Y-m-d H:i:s'); 
             $updated=date('Y-m-d H:i:s');

              $fulldata= Master::getFullDetails($catname,$serialno,$oname,$modname,$lname,$v['prt_no'],$v['prt_desc']);
              if($fulldata){
                $master = Master::find($fulldata->id);
               $master->prt_qty   = ($fulldata->prt_qty+$v['prt_qty']);
               $master->save();
             }
             else{

 				$insert = ['cat_id' => $catname,'serial_id' => $serialno,'oem_id' => $oname, 'mod_id' => $modname, 'loc_id' => $lname, 'prt_no' => $v['prt_no'], 'prt_desc' => $v['prt_desc'], 'prt_qty' => $v['prt_qty'], 'sn' => $v['sn'], 'serial_no' => $v['serial_no'], 'track' => $v['track'], 'location_of_tray' => $v['location_of_tray'], 'mas_status' => '1','start_date' => $created,'end_date'=> $created, 'created_at' => $created, 'updated_at'=> $updated ];
        //print_r($insert);exit;
 				if(!empty($insert)){
 					Master::insert($insert);
 				}
      }

 						}
 					}
 				 
 	
 					return back()->with('success','Insert Record successfully.');
         

 			}

 		}

 		return back()->with('error','Please Check your file, Something is wrong there.');
 	}

  /*engg csv upload*/
  public function timportExcel(Request $request)
    {

    if($request->hasFile('import_file')){
      $path = $request->file('import_file')->getRealPath();

      $data = Excel::load($path, function($reader) {})->get();
       $filename = time().'.'.$request->import_file->getClientOriginalExtension();
 $t=$request->import_file->move('uploaded_csv', $filename);
//echo 'Ticket'; exit;
      if(!empty($data) && $data->count()){

        foreach ($data->toArray() as $key => $v) {
          if(!empty($v)){
            //foreach ($value as $key2 => $v) {     
              $catname=  Master::getCatIdByName($v['asset']);
              if($catname)
              $catname= $catname->id;
              else
              {
              $catNew = Category::create([
                   'cat_name' => $v['asset'],
                   'cat_status' => '1',
                              ]);
              $catname = $catNew->id;
             }
               $serialno=  Master::getSerialIdByName($catname,$v['asset_serial_no']); 
              if($serialno)
              $serialno= $serialno->id;
            else
            {
              $SerNew = Serial::create([
                   'cat_id' => $catname,
                   'serial_no' => $v['asset_serial_no'],
                              ]);
              $serialno = $SerNew->id;
            }

            $oemname=  Master::getOemIdByName($catname,$serialno,$v['oem']);
              if($oemname)
              $oname= $oemname->id;
              else
              {
              $oemNew = Oem::create([
                   'cat_id'   =>$catname,
                   'serial_id'=>$serialno,
                   'oem_name' => $v['oem'],
                   'oem_status' => '1',
                              ]);
              $oname = $oemNew->id;
             }
              $modelName= Master::getModIdByName($catname,$serialno,$oname,$v['model']);

             if($modelName)
              $modname= $modelName->id;
              
              else
              {
              $modNew = Oemmodel::create([
                   'cat_id'   =>$catname,
                   'serial_id'=>$serialno,
                   'oem_id'=>$oname,
                   'mod_name' => $v['model'],
                   'mod_status' => '1',
                              ]);
              $modname = $modNew->id;
             }
$conName= Master::getConIdByName($v['country']);
             if($conName)
              $cname= $conName->id;

            
              else
              {
              $cNew = Country::create([
                   'con_name'=>$v['country'],
                   'con_status'=>'1',
                              ]);
              $cname = $cNew->id;
             }
$stName= Master::getStateIdByName($cname,$v['state']);
             if($stName)
              $sname= $stName->id;

              else
              {
              $sNew = State::create([
                   'con_id'=>$cname,
                   'st_name'=>$v['state'],
                   'st_status'=>'1',
                              ]);
              $sname = $sNew->id;
             }
  $ctName= Master::getCityIdByName($sname,$v['city']);
             if($ctName)
              $ccname= $ctName->id;

              
              else
              {
              $ccNew = City::create([
                   'st_id'=>$sname,
                   'ct_name'=>$v['city'],
                   'ct_status'=>'1',
                              ]);
              $ccname = $ccNew->id;
             }

 $locName= Master::getLocIdByName($cname,$sname,$ccname,$v['location']);
             if($locName)
              $lname= $locName->id;

            
              else
              {
              $locNew = Location::create([
                   'con_id'=>$cname,
                   'st_id'=>$sname,
                   'ct_id'=>$ccname,
                   'loc_name'=>$v['location'],
                   'loc_status'=> '1', 
                              ]);
              $lname = $locNew->id;
             }

             $created=date('Y-m-d H:i:s'); 
             $updated=date('Y-m-d H:i:s');

              $fulldata= Master::getFullDetails($catname,$serialno,$oname,$modname,$lname,$v['prt_no'],$v['prt_desc']);
              if($fulldata){
                $master = Master::find($fulldata->id);
               $master->prt_qty   = ($fulldata->prt_qty+$v['prt_qty']);
               $master->save();
             }
             else{

        $insert = ['cat_id' => $catname,'serial_id' => $serialno,'oem_id' => $oname, 'mod_id' => $modname, 'loc_id' => $lname, 'prt_no' => $v['prt_no'], 'prt_desc' => $v['prt_desc'], 'prt_qty' => $v['prt_qty'], 'sn' => $v['sn'], 'serial_no' => $v['serial_no'], 'track' => $v['track'], 'location_of_tray' => $v['location_of_tray'], 'mas_status' => '1','start_date' => $created,'end_date'=> $created, 'created_at' => $created, 'updated_at'=> $updated ];
        if(!empty($insert)){
          Master::insert($insert);
        }
      }

            }
          }
         
  
          return back()->with('success','Insert Record successfully.');
         

      }

    }

    return back()->with('error','Please Check your file, Something is wrong there.');
  }
}
