<?php

namespace Ticket\Http\Controllers;

use Illuminate\Http\Request;
use Ticket\Serial;
use Ticket\Category;
use Ticket\Http\Controllers\Controller;

use Validator;
use Illuminate\Support\Facades\Input;

class SerialController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $categories = Category::all();
        $serials = Serial::getSerial();

        return view('admin.serials.addserial',compact('categories','serials'));
    }

    public function tindex()
    {
        $categories = Category::all();
        $serials = Serial::getSerial();

        return view('engineer.serials.addserial',compact('categories','serials'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    { 
        if ($request->isMethod('post')) {


       $this->validate($request, [
           'category' => 'required',
           'serialno' => 'required|max:50',
           //'sla' => 'required',
           //'datepicker' => 'required',
           //'datepicker2' => 'required'
       ]);
 
           $serial = new Serial;
           //print_r($request); die;
           $start_date=    date('Y-m-d H:i:s',strtotime($request->datepicker)); 
           $end_date = date('Y-m-d H:i:s',strtotime($request->datepicker2));

               $serial->cat_id     = $request->category;
               $serial->serial_no     = $request->serialno;
               //$serial->sla     = $request->sla;
              //$serial->start_date =  $start_date;
               //$serial->end_date     = $end_date;
             
             if($serial->save()) {
               //$request->session()->flash('success', 'Asset Serial Nos Added Successfully');
               //return redirect()->route("serial.index");
                 return back()->with('success', 'Asset Serial Nos Added Successfully');
             }


     }
    }

    

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $serial = Serial::find($id);
        //$serials = Serial::all();
        $cats = Category::all();
        return view('admin.serials.editserial',compact('cats','serial'));
    }

    //for engineer
    public function tedit($id)
    {
        $serial = Serial::find($id);
        //$serials = Serial::all();
        $cats = Category::all();
        return view('engineer.serials.editserial',compact('cats','serial'));
    }


    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        if ($request->isMethod('patch')) {
        $this->validate($request, [
            'category'  =>'required',
            'serialno'  => 'required',
            //'sla' => 'required|max:50',
            //'datepicker'  =>'required',
            //'datepicker2'  =>'required'
        ]);

        $start_date=    date('Y-m-d H:i:s',strtotime($request->datepicker)); 
        $end_date = date('Y-m-d H:i:s',strtotime($request->datepicker2));

        $serial = Serial::find($id);
        $serial->cat_id      = $request->category;
        $serial->serial_no  =$request->serialno;
        //$serial->sla   = $request->sla;
        //$serial->start_date =  $start_date;
        //$serial->end_date     = $end_date;
        
        if($serial->save()) {
          $request->session()->flash('success', 'Asset Serial Updated Successfully');
          return redirect()->route("serial.index");
        }

      }
    }

    //engineer module
     public function tupdate(Request $request)
    {
        if ($request->isMethod('post')) {
        $this->validate($request, [
            'category'  =>'required',
            'serialno'  => 'required',
            //'sla' => 'required|max:50',
            //'datepicker'  =>'required',
            //'datepicker2'  =>'required'
        ]);

        //$start_date=    date('Y-m-d H:i:s',strtotime($request->datepicker)); 
        //$end_date = date('Y-m-d H:i:s',strtotime($request->datepicker2));

        $serial = Serial::find($request->id);
        $serial->cat_id      = $request->category;
        $serial->serial_no  =$request->serialno;
        //$serial->sla   = $request->sla;
        //$serial->start_date =  $start_date;
        //$serial->end_date     = $end_date;
        
        if($serial->save()) {
          $request->session()->flash('success', 'Asset Serial Updated Successfully');
          return redirect("tserindex");
        }

      }
    }


    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $serial = Serial::find($id);
        if($serial->delete()){

            //return redirect()->route("oem.index")->with('success', 'Deleted successfully');
            return back()->with('success', 'Deleted successfully');
        }else{
            //return redirect()->route("oem.index")->with('error','Delete failed');
            return back()->with('error', 'Delete failed');
        }

    }
}
