<?php

namespace Ticket;

use Illuminate\Database\Eloquent\Model;
use DB;

class Master extends Model
{

  protected static function getModelByOem($id) {
    $models = DB::table('oemmodels')->select("mod_name","id")
                ->where("oem_id", '=', $id)->get();

              // $queries = DB::getQueryLog();
           //echo '<pre>'; print_r($models);die;
             //print_r($models);die;   
    return $models;
  }

  protected static function getOemname() {
   $results = DB::table('masters')
   ->select('masters.id','masters.oem_id','masters.mod_id','masters.loc_id','masters.prt_no','masters.prt_desc','masters.prt_qty','masters.sn','masters.start_date','masters.end_date','oems.oem_name','oemmodels.mod_name','locations.loc_name','categories.cat_name', 'countries.con_name', 'states.st_name', 'cities.ct_name','serials.serial_no')
   ->join('categories', 'categories.id', '=', 'masters.cat_id')
   ->join('oems', 'oems.id', '=', 'masters.oem_id')
   ->join('serials', 'serials.id', '=', 'oems.serial_id')
   ->join('oemmodels', 'oemmodels.id', '=', 'masters.mod_id')

   ->join('locations', 'locations.id', '=', 'masters.loc_id')
   ->join('cities', 'cities.id', '=', 'locations.ct_id')
   ->join('states', 'states.id', '=', 'locations.st_id')
   ->join('countries', 'countries.id', '=', 'locations.con_id')

   ->where('oems.oem_status', '=', '1')
   ->get(); // Notice the shares.* here
   //var_dump($results); die; 

  return $results;
  }


protected static function getSerachResult($text) {

   $results = DB::table('masters')
   ->select('masters.id','masters.oem_id','masters.mod_id','masters.loc_id','masters.prt_no','masters.prt_desc','masters.prt_qty','masters.sn','masters.start_date','masters.end_date','oems.oem_name','oemmodels.mod_name','locations.loc_name','categories.cat_name','countries.con_name', 'states.st_name', 'cities.ct_name','serials.serial_no')
   ->join('categories', 'categories.id', '=', 'masters.cat_id')
   ->join('serials', 'serials.id', '=', 'masters.serial_id')
   ->join('oems', 'oems.id', '=', 'masters.oem_id')
   ->join('oemmodels', 'oemmodels.id', '=', 'masters.mod_id')
   ->join('locations', 'locations.id', '=', 'masters.loc_id')
   ->join('cities', 'cities.id', '=', 'locations.ct_id')
   ->join('states', 'states.id', '=', 'locations.st_id')
   ->join('countries', 'countries.id', '=', 'locations.con_id')
   ->orWhere('masters.serial_no','like', '%' . $text. '%')
    ->orWhere('masters.prt_no', 'like', '%' . $text. '%')
    ->orWhere('masters.prt_desc', 'like', '%' . $text. '%')
    ->orWhere('locations.loc_name', 'like', '%' . $text. '%')
    ->orWhere('cities.ct_name', 'like', '%' . $text. '%')
    ->orWhere('states.st_name', 'like', '%' . $text. '%')
    ->orWhere('countries.con_name', 'like', '%' . $text. '%')
      ->get(); // Notice the shares.* here
   //var_dump($results); die; 

  return $results;
  }


protected static function getCatIdByName($name) {
    $categories = DB::table('categories')->select("id")
                ->where("cat_name", '=', $name)->first();              
    return $categories;
  }

  protected static function getSerialIdByName($catname,$name) {
    $serial_no = DB::table('serials')->select("id")
                ->where("cat_id", '=', $catname)
                ->where("serial_no", '=', $name)->first();              
    return $serial_no;
  }

  
  protected static function getOemIdByName($catname,$serialno,$name) {
    $oems = DB::table('oems')->select("id")
              ->where("cat_id", '=', $catname)
              ->where("serial_id", '=', $serialno)
                ->where("oem_name", '=', $name)->first(); 
               //print_r($oems); exit();
    return $oems;
  }

  protected static function getModIdByName($catname,$serialno,$oem,$modname) {
    $models = DB::table('oemmodels')->select("id")
              ->where("cat_id", '=', $catname)
              ->where("serial_id", '=', $serialno)
              ->where("oem_id", '=', $oem)
              ->where("mod_name", '=', $modname)->first();

              // $queries = DB::getQueryLog();
          // echo '<pre>'; print_r($queries);die;
    return $models;
  }

  protected static function getLocIdByName($conName,$stname,$ctname,$locname) {
    $locs = DB::table('locations')->select("id")
    ->where("con_id", '=', $conName)
    ->where("st_id", '=', $stname)  
    ->where("ct_id", '=', $ctname)  
    ->where("loc_name", '=', $locname)->first();

              // $queries = DB::getQueryLog();
          // echo '<pre>'; print_r($queries);die;
    return $locs;
  }

  protected static function getConIdByName($conname) {
    $cons = DB::table('countries')->select("id")
                ->where("con_name", '=', $conname)->first();

              // $queries = DB::getQueryLog();
          // echo '<pre>'; print_r($queries);die;
    return $cons;
  }

  protected static function getStateIdByName($conName,$stname) {
    $state = DB::table('states')->select("id")
               ->where("con_id", '=', $conName)
                ->where("st_name", '=', $stname)->first();

              // $queries = DB::getQueryLog();
          // echo '<pre>'; print_r($queries);die;
    return $state;
  }

  protected static function getCityIdByName($stname,$ctname) {
    $city = DB::table('cities')->select("id")    
      ->where("st_id", '=', $stname)      
      ->where("ct_name", '=', $ctname)->first();
    return $city;
  }
   protected static function getFullDetails($catname,$serialno,$oname,$modname,$lname,$prt_no,$prt_desc) {
    $fulldata = DB::table('masters')->select("id","prt_qty")
    ->where("cat_id", '=', $catname)
    ->where("serial_id", '=', $serialno)    
    ->where("oem_id", '=', $oname)
    ->where("mod_id", '=', $modname)
    ->where("loc_id", '=', $lname)
    ->where("prt_no", '=', $prt_no)
    ->where("prt_desc", '=', $prt_desc)->first();

              // $queries = DB::getQueryLog();
          // echo '<pre>'; print_r($queries);die;
    return $fulldata;
  }
  

}
